import 'package:flutter/material.dart';

class TitleText extends StatelessWidget {
  final String text;
  final bool centered;

  TitleText({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.title,
    );
  }
}

class CaptionText extends StatelessWidget {
  final String text;
  final bool centered;

  CaptionText({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.caption,
    );
  }
}

class Body1Text extends StatelessWidget {
  final String text;
  final bool centered;

  Body1Text({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.body1,
    );
  }
}

class Body2Text extends StatelessWidget {
  final String text;
  final bool centered;

  Body2Text({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.body2,
    );
  }
}

class OverlineText extends StatelessWidget {
  final String text;
  final bool centered;

  OverlineText({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.overline,
    );
  }
}

class HeadlineText extends StatelessWidget {
  final String text;
  final bool centered;

  HeadlineText({Key key, @required this.text, this.centered}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return _Text(
      text: text,
      centered: centered,
      style: Theme.of(context).textTheme.headline,
    );
  }
}

class _Text extends StatelessWidget {
  final String text;
  final bool centered;
  final TextStyle style;

  _Text({
    Key key,
    @required this.text,
    this.centered = false,
    this.style,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final _text = Text(
      text ?? '',
      style: style,
      textAlign: (centered ?? false) ? TextAlign.center : TextAlign.start,
    );
    if (centered != null && centered) {
      return Center(
        child: _text,
      );
    } else {
      return _text;
    }
  }
}
